=== debian/changelog ===
qtltools (1.1+dfsg-2build1) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:22:50 +0000

qtltools (1.1+dfsg-2) unstable; urgency=medium

  [ Dylan Aïssi ]
  * Remove examples.tar.xz during dh_auto_clean in order
     to improve reproducible builds. (Closes: #857454)
     (Thanks to Chris Lamb)
  * Add OMICtools ref.

  [ Andreas Tille ]
  * cme fix dpkg-control

 -- Dylan Aïssi <bob.dybian@gmail.com>  Wed, 19 Jul 2017 23:54:14 +0200

qtltools (1.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstram version
  * d/watch: version=4

 -- Andreas Tille <tille@debian.org>  Mon, 16 Jan 2017 10:06:15 +0100

qtltools (1.0+dfsg-2) unstable; urgency=medium

  * Add a patch to fix reproducible builds. (Closes: #848280)
     (Thanks to Reiner Herrmann <reiner@reiner-h.de>)

 -- Dylan Aïssi <bob.dybian@gmail.com>  Fri, 16 Dec 2016 22:12:04 +0100

qtltools (1.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #845590)

 -- Dylan Aïssi <bob.dybian@gmail.com>  Fri, 02 Dec 2016 23:35:41 +0100
