=== debian/control ===
Source: qtltools
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Dylan Aïssi <bob.dybian@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               libblas-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libbz2-dev,
               libeigen3-dev,
               libgsl-dev,
               libhts-dev,
               r-mathlib,
               zlib1g-dev
Standards-Version: 4.0.0
Vcs-Browser: https://anonscm.debian.org/git/debian-med/qtltools.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/qtltools.git
Homepage: https://qtltools.github.io/qtltools/

Package: qtltools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: qtltools-example
Description: Tool set for molecular QTL discovery and analysis
 QTLtools is a tool set for molecular Quantitative Trait Loci (QTL) discovery
 and analysis. It allows user to go from the raw sequence data to collection of
 molecular QTL in few easy-to-perform steps. QTLtools contains multiple methods
 to prepare the data, to discover proximal and distal molecular QTL and to
 finally integrate them with GWAS variants and functional annotations of the
 genome.

Package: qtltools-example
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Enhances: qtltools
Description: Tool set for molecular QTL discovery and analysis - example
 QTLtools is a tool set for molecular Quantitative Trait Loci (QTL) discovery
 and analysis. It allows user to go from the raw sequence data to collection of
 molecular QTL in few easy-to-perform steps. QTLtools contains multiple methods
 to prepare the data, to discover proximal and distal molecular QTL and to
 finally integrate them with GWAS variants and functional annotations of the
 genome.
 .
 This package provides example data to work with QTLtools.
