=== debian/changelog ===
qtltools (1.2+dfsg-2build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:28:25 +0000

qtltools (1.2+dfsg-2) unstable; urgency=medium

  * Team upload.
  * debian/rules: on mipsel, skip debug info to fit into 4 GB of memory

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 25 Dec 2019 22:27:16 +0100

qtltools (1.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update d/copyright.
  * Bump Standards-Version to 4.4.1 (no changes needed).
  * Bump debhelper compat 12.

 -- Dylan Aïssi <daissi@debian.org>  Mon, 30 Sep 2019 23:26:57 +0200

qtltools (1.1+dfsg-3) unstable; urgency=medium

  * Team upload.

  [ Dylan Aïssi ]
  * Fix registries ref.
  * Update metadata references.
  * Canonical Vcs-Browser.
  * Bump Standards-Version to 4.1.1 (no changes needed).

  [ Andreas Tille ]
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Thu, 13 Sep 2018 16:07:01 +0200
