=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: qtltools
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Dylan Aïssi <bob.dybian@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Dylan Aïssi <daissi@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 12~),
                libblas-dev,
                libboost-iostreams-dev,
                libboost-program-options-dev,
@@ -13,9 +14,9 @@
                libhts-dev,
                r-mathlib,
                zlib1g-dev
-Standards-Version: 4.0.0
-Vcs-Browser: https://anonscm.debian.org/git/debian-med/qtltools.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/qtltools.git
+Standards-Version: 4.4.1
+Vcs-Browser: https://salsa.debian.org/med-team/qtltools
+Vcs-Git: https://salsa.debian.org/med-team/qtltools.git
 Homepage: https://qtltools.github.io/qtltools/
 
 Package: qtltools
