=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,9 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CPPFLAGS_MAINT_APPEND = -I/usr/include/eigen3
+ifneq (,$(filter $(DEB_HOST_ARCH),i386 kfreebsd-i386 hurd-i386 armel armhf mipsel))
+	export DEB_CXXFLAGS_MAINT_APPEND = -g0
+endif
 
 %:
 	dh $@
@@ -18,4 +21,3 @@
 override_dh_install:
 	cd debian/upstream.example && find -type f | LC_ALL=C sort | tar -T - --sort=name --mode=go=rX,u+rw,a-s --owner=root --group=root --numeric-owner -Jcvf examples.tar.xz
 	dh_install
-
