## qtltools 1.3.1%2Bdfsg

=== debian/changelog ===
qtltools (1.3.1+dfsg-4build4) oracular; urgency=medium

  * Rebuild against new libgsl28.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Jul 2024 10:32:00 +0200

qtltools (1.3.1+dfsg-4build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:33:48 +1100

qtltools (1.3.1+dfsg-4build2) noble; urgency=high

  * No change rebuild against libhts3t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:51:47 +0100

qtltools (1.3.1+dfsg-4build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:55:26 +0100

qtltools (1.3.1+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Recommends: s/r-cran-qvalue/r-bioc-qvalue/
    Closes: #1021423
  * Move bash completions to correct dir

 -- Andreas Tille <tille@debian.org>  Mon, 05 Dec 2022 16:43:51 +0100

qtltools (1.3.1+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Normalise github watch file
  * Standards-Version: 4.6.1 (routine-update)
  * Recommends: r-cran-qvalue
  * Depends: r-base-core

 -- Andreas Tille <tille@debian.org>  Thu, 06 Oct 2022 15:29:06 +0200

qtltools (1.3.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Install the new files in appropriate locations.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 13 Oct 2020 17:56:30 +0200

qtltools (1.3.1+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Make really sure examples.tar.xz will not contain itself
  * debhelper-compat 12
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).

  [ Dylan Aïssi ]
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)

  [ Michael R. Crusoe ]
  * debian/patches/Makefile_config.patch: refresh
  * Fix uses-deprecated-adttmp debian/tests/run-sample-analysis
  * debian/upstream/metadata: added Repository{,-Browse} and
    Bug-{Database,Submit}.
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * script/ is now scripts/

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 10 Oct 2020 18:04:50 +0200
