=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Dylan Aïssi <daissi@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (= 13),
                libblas-dev,
                libboost-iostreams-dev,
                libboost-program-options-dev,
@@ -14,15 +14,18 @@
                libhts-dev,
                r-mathlib,
                zlib1g-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/qtltools
 Vcs-Git: https://salsa.debian.org/med-team/qtltools.git
 Homepage: https://qtltools.github.io/qtltools/
+Rules-Requires-Root: no
 
 Package: qtltools
 Architecture: any
 Depends: ${shlibs:Depends},
-         ${misc:Depends}
+         ${misc:Depends},
+         r-base-core
+Recommends: r-bioc-qvalue
 Suggests: qtltools-example
 Description: Tool set for molecular QTL discovery and analysis
  QTLtools is a tool set for molecular Quantitative Trait Loci (QTL) discovery
