=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/qtltools/qtltools/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

# https://qtltools.github.io/qtltools/pages/basic_install.html https://qtltools.github.io/qtltools/binaries/QTLtools_(\d\S*)_source\.tar\.gz
